Description

Currently the app directories are added to the eager_load paths if the environment name is production.

see: source:trunk/lib/redmine/plugin.rb@17293#96

The decision to add the path to the eager _load paths should depend on the_ eager_load_ setting (

Rails.application.config.eager_load) instead of the environment name.

Rails 5 disables autoloading in case eager _load is enabled so using a different environment (e.g. staging) that also enables
eager_load will result in plugin classes (e.g. models) are not loaded (uninitialized constant) in this environment.

The attached patch fixes this to use the eager_load setting to decide if the paths should be added to eager _load.

Related issues:
Related to Redmine - Defect #26636: Rails 5: "Page not found" error when acce...
Related to Redmine - Defect #30753: Plugins auto_load and eager_load paths

Closed
Closed

Associated revisions

Revision 17841 - 2019-02-01 10:03 - Go MAEDA

Plugin eager_load should depend on environment setting instead of name (#30725).

Patch by Florian Schwab.

Revision 17842 - 2019-02-01 11:12 - Go MAEDA
Merged r17841 from trunk to 4.0-stable (#30725).

History

#1 - 2019-01-31 10:04 - Florian Schwab

Sorry, | forgot to change the tracker to Patch.

#2 - 2019-01-31 10:38 - Go MAEDA

- Tracker changed from Defect to Patch

#3 - 2019-01-31 12:14 - Marius BALTEANU
- File plugin_eager_load.patch added

#4 - 2019-01-31 12:15 - Marius BALTEANU

Fixed the extension name in order to be able to preview the patch in browser.

#5 - 2019-01-31 12:15 - Marius BALTEANU
- File deleted (plugin_eager_load.path)

#6 - 2019-02-01 02:21 - Go MAEDA
- Category set to Rails support

- Target version set to 4.0.2

Setting the target version to 4.0.2.
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/plugin.rb?rev=17293%2396

#7 - 2019-02-01 02:25 - Go MAEDA

- Related to Defect #26636: Rails 5: "Page not found" error when accessing a page of a plugin in production mode added

#8 - 2019-02-01 10:07 - Go MAEDA
- Status changed from New to Resolved

- Assignee set to Go MAEDA

Committed. Thank you for detecting and fixing the issue.

#9 - 2019-02-01 11:12 - Go MAEDA

- Status changed from Resolved to Closed

#10 - 2019-02-24 03:03 - Go MAEDA
- Related to Defect #30753: Plugins auto_load and eager_load paths added
